	INCDIR	"Include:"

	include	"lvo.i"

	INCLUDE	"Exec/exec.i"
	include	"intuition/screens.i"
	INCLUDE	"Graphics/gfxbase.i"
	include	"graphics/videocontrol.i"
	INCLUDE	"Hardware/custom.i"
	INCLUDE	"Hardware/dmabits.i"
	INCLUDE	"Hardware/cia.i"
	INCLUDE	"Hardware/intbits.i"

_custom	equ	$dff000

************************************************************************

 STRUCTURE gldata,0
	APTR	_SaveSP
	APTR	_SaveVBR
	APTR	_OldVB

	APTR	_ExecBase
	APTR	_DosBase
	APTR	_IntuitionBase
	APTR	_GfxBase

	WORD	_intreq
	WORD	_intena
	ALIGNLONG

	APTR	wbview				; WB view pointer
	APTR	wbscreen				; the WB screen

	APTR	copperlist
	APTR	_copperlist

	APTR	screenbuffer
	APTR	_screenbuffer

	APTR	hugebuffer

	STRUCT	animtbl,4*4

	LONG	oldres
	LONG	oldtaskpri
	APTR	taskptr
	STRUCT	taglist,8*2+4,0

	; *** triggers for interrupt

	BYTE	TRIG_DOWIPEBL		; stop doeff and wipe to black
	BYTE	TRIG_TEXT		; set to plot text
	BYTE	TRIG_DOEFF		; do pause effect no.
	ALIGNLONG
	APTR	TEXT_PTR			; ptr to text if TRIG_TEXT
	LONG	TRIG_ANIM		; set to do anim

	WORD	CTR_FRAME		; current frame
	WORD	CTR_DIR

	WORD	currfr
	WORD	prevfr

	WORD	xoffset
	WORD	yoffset

	WORD	adder

	BYTE	cnt
	ALIGNWORD

	; interrupt data - for text handling
	WORD	letter			; last letter offset
	WORD	horizpos			; last letter pixel+1 at this x coord
	WORD	waits			; frames waited
	WORD	currwait			; frames to wait

	; interrupt data - for effects
	WORD	xpos
	WORD	ypos
	WORD	thiscol


	BYTE	vb_ok
	BYTE	disable_ok

	ALIGNLONG
	STRUCT	chunkytable,92*4

	ALIGNLONG
	STRUCT	scalebuf,200
	STRUCT	scalebuf2,200
	STRUCT	sizetbl,200

	ALIGNLONG
	STRUCT	logobuffer,92*36*2

	ALIGNLONG
	STRUCT	framebuffer,184*184*2

	ALIGNLONG
	STRUCT	framebuffer2,184*184*2

 LABEL gldata_SIZEOF

COPPERLINES	equ	92

 STRUCTURE a_copperlist,0
	LONG	fetchmode
	LONG	initwait
	LONG	spr0
	LONG	spr1
	LONG	spr2
	LONG	spr3
	LONG	spr4
	LONG	spr5
	LONG	spr6
	LONG	spr7
	STRUCT	bplptrs,8*4*2

	LONG	dma_con
	LONG	bpl_con0

	LONG	bpl_1mod
	LONG	bpl_2mod

	LONG	diw_strt
	LONG	diw_stop

	LONG	ddf_strt
	LONG	ddf_stop

	LONG	bpl_con1
	LONG	bpl_con2

	STRUCT	back_pen1col,3*4

	STRUCT	block,(96*(COPPERLINES+2))*4

	STRUCT	endofclist,20*4			; ca. & not addressable

 LABEL copperlist_SIZEOF

******************************************************************
MO:	MACRO
	dc.w	\2 & -2
	dc.w	\1
	ENDM
WA:	MACRO
	dc.b	\2
	dc.b	\1 ! 1
	dc.w	$FFFE
	ENDM
WM:	MACRO
	dc.b	\2
	dc.b	\1 ! 1
	dc.w	\3 & -2
	ENDM
SK:	MACRO
	dc.b	\2
	dc.b	\1 ! 1
	dc.w	\3 ! 1
	ENDM

COP1LCH = $080
COP1LCL = $082
COP2LCH = $084
COP2LCL = $086
COPJMP1 = $088
COPJMP2 = $08A

DIWSTRT = $08E
DIWSTOP = $090
DDFSTRT = $092
DDFSTOP = $094

BPL1PTH = $0E0
BPL1PTL = $0E2
BPL2PTH = $0E4
BPL2PTL = $0E6
BPL3PTH = $0E8
BPL3PTL = $0EA
BPL4PTH = $0EC
BPL4PTL = $0EE
BPL5PTH = $0F0
BPL5PTL = $0F2
BPL6PTH = $0F4
BPL6PTL = $0F6
BPL7PTH = $0F8
BPL7PTL = $0FA
BPL8PTH = $0FC
BPL8PTL = $0FE

BPLCON0 = $100
BPLCON1 = $102
BPLCON2 = $104

BPL1MOD = $108
BPL2MOD = $10A

BPL1DAT = $110
BPL2DAT = $112
BPL3DAT = $114
BPL4DAT = $116
BPL5DAT = $118
BPL6DAT = $11A

COLOR00 = $180
COLOR01 = $182
COLOR02 = $184
COLOR03 = $186
COLOR04 = $188
COLOR05 = $18A
COLOR06 = $18C
COLOR07 = $18E
COLOR08 = $190
COLOR09 = $192
COLOR10 = $194
COLOR11 = $196
COLOR12 = $198
COLOR13 = $19A
COLOR14 = $19C
COLOR15 = $19E
COLOR16 = $1A0
COLOR17 = $1A2
COLOR18 = $1A4
COLOR19 = $1A6
COLOR20 = $1A8
COLOR21 = $1AA
COLOR22 = $1AC
COLOR23 = $1AE
COLOR24 = $1B0
COLOR25 = $1B2
COLOR26 = $1B4
COLOR27 = $1B6
COLOR28 = $1B8
COLOR29 = $1BA
COLOR30 = $1BC
COLOR31 = $1BE

DMACON  = $096

SPR0PTH = $120
SPR0PTL = $122
SPR1PTH = $124
SPR1PTL = $126
SPR2PTH = $128
SPR2PTL = $12A
SPR3PTH = $12C
SPR3PTL = $12E
SPR4PTH = $130
SPR4PTL = $132
SPR5PTH = $134
SPR5PTL = $136
SPR6PTH = $138
SPR6PTL = $13A
SPR7PTH = $13C
SPR7PTL = $13E

SPR0DATA = $144
SPR1DATA = $14C
SPR2DATA = $154
SPR3DATA = $15C
SPR4DATA = $164
SPR5DATA = $16C
SPR6DATA = $174
SPR7DATA = $17C
