; ***********************************************
; "Invention AGA" by Triumph Software 1994
; ***********************************************
; Released at The Gathering 1994 for the 40k
; intro competition.
; ***********************************************
; Code:  Nils "Darkman" Corneliusen
; Gfx:   Rico "Winter Mute" Holmes
; Font:  Bjrn Rybakken
; Music: Paul van der Valk
; ***********************************************
; PRELIMINARY AND CONFIDENTIAL!
; ***********************************************

; Minor timing bugfix done in 2020.
; -- Nils Liaaen Corneliusen

INTUI_V36_NAMES_ONLY	equ	1

	MACHINE	MC68020

	OUTPUT	ram:intro
	OPT	C+				; Case insensitivity?
	OPT	D-				; Debug info?
	OPT	L-				; Linkable code?
	OPT	P+				; PC checking?

;	incdir	"source:tg94/"
	include	"global.i"


start:
	move.l	#gldata_SIZEOF,d0
	move.l	#MEMF_PUBLIC!MEMF_CLEAR,d1
	move.l	4.w,a6
	jsr	_LVOAllocMem(a6)

	movea.l	d0,a5

	tst.l	d0
	bne.b	.hey

	rts

.hey:	lea	HARDBASE(pc),a0
	move.l	a5,(a0)
	move.l	a6,_ExecBase(a5)
	move.l	a7,_SaveSP(a5)

	move.l	#(40*256*8)+8,d0
	move.l	#MEMF_CHIP!MEMF_CLEAR,d1
	move.l	_ExecBase(a5),a6
	jsr	_LVOAllocMem(a6)

	move.l	d0,_screenbuffer(a5)
	beq	QuitNice

	addq.l	#8,d0
	and.l	#-8,d0				; 64 bit alignment

	move.l	d0,screenbuffer(a5)

	move.l	#copperlist_SIZEOF+8,d0
	move.l	#MEMF_CHIP!MEMF_CLEAR,d1
	move.l	_ExecBase(a5),a6
	jsr	_LVOAllocMem(a6)

	move.l	d0,_copperlist(a5)
	beq	QuitNice

	addq.l	#8,d0
	and.l	#-8,d0				; 64 bit alignment

	move.l	d0,copperlist(a5)

	; allocate huge anim buffer
	move.l	#92*92*2*90,d0
	move.l	#MEMF_PUBLIC!MEMF_CLEAR,d1
	move.l	_ExecBase(a5),a6
	jsr	_LVOAllocMem(a6)

	move.l	d0,hugebuffer(a5)
	beq	QuitNice

	bsr	Init


	; *** find task pointer and change priority
	sub.l	a1,a1
	move.l	_ExecBase(a5),a6
	jsr	_LVOFindTask(a6)

	move.l	d0,taskptr(a5)

	movea.l	d0,a1
	moveq	#127,d0
	jsr	_LVOSetTaskPri(a6)

	move.b	d0,oldtaskpri+3(a5)

	lea	intname(pc),a1
	moveq	#0,d0
	jsr	_LVOOpenLibrary(a6)

	move.l	d0,_IntuitionBase(a5)
	beq	QuitNice

	lea	dosname(pc),a1
	moveq	#0,d0
	jsr	_LVOOpenLibrary(a6)

	move.l	d0,_DosBase(a5)
	beq	QuitNice

	lea	gfxname(pc),a1
	moveq	#0,d0
	jsr	_LVOOpenLibrary(a6)

	move.l	d0,_GfxBase(a5)
	beq	QuitNice

	move.l	d0,a6
	move.l	gb_ActiView(a6),wbview(a5)

	bsr	FixSpritesSetup         	; fix sprite "bug"...

	move.l	_GfxBase(a5),a6

	sub.l	a1,a1
	jsr	_LVOLoadView(a6)
	jsr	_LVOWaitTOF(a6)
	jsr	_LVOWaitTOF(a6)

	move.l	_ExecBase(a5),a6
	jsr	_LVOForbid(a6)
	move.b	#1,disable_ok(a5)

	lea	_custom,a6
	move.w	intreqr(a6),_intreq(a5)
	move.w	#%0111111111111111,intreq(a6)	; clear all requests

	move.w	intenar(a6),_intena(a5)
	move.w	#%0111111111110000,intena(a6)


	; *** Get vbr pointer ***

	move.l	a5,-(a7)
	move.l	_ExecBase(a5),a6
	lea	getvbr(pc),a5
	jsr	_LVOSupervisor(a6)
	move.l	(a7)+,a5

	move.l	d0,_SaveVBR(a5)

	move.l	a5,-(a7)
	lea	mod,a0
	moveq	#0,d0
	jsr	(a0)
	move.l	(a7)+,a5


	; *** set a new cool interrupt.
	; *** we are already disabled.
	movea.l	_SaveVBR(a5),a4
	move.l	$6c(a4),_OldVB(a5)
	lea	VBHandler(pc),a0
	move.l	a0,$6c(a4)
	move.b	#1,vb_ok(a5)



	lea	_custom,a6

	move.l	copperlist(a5),cop1lc(a6)
	move.w	#DMAF_SETCLR!DMAF_COPPER!DMAF_RASTER,dmacon(a6)

	clr.w	copjmp1(a6)			; strobe - start copper1

	move.w	#INTF_SETCLR!INTF_INTEN!INTF_VERTB,intena(a6)

	bsr	Main

	bra	QuitNice


; ***********************************************
; getvbr: Launched from Supervisor()
; ***********************************************

getvbr:
	movec	vbr,d0
	rte


; ***********************************************
; FixSpritesSetup
; ***********************************************

FixSpritesSetup:
	move.l	_IntuitionBase(a5),a6
	lea	wbname(pc),a0
	jsr	_LVOLockPubScreen(a6)

	move.l	d0,wbscreen(a5)
	beq.b	.error

	movea.l	d0,a0

	movea.l	sc_ViewPort+vp_ColorMap(a0),a0

	lea	taglist(a5),a1
	move.l	#VTAG_SPRITERESN_GET,(a1)+
	move.l	#SPRITERESN_ECS,(a1)+
	move.l	#TAG_DONE,(a1)

	lea	taglist(a5),a1
	move.l	_GfxBase(a5),a6
	jsr	_LVOVideoControl(a6)

	lea	taglist(a5),a1
	move.l	4(a1),oldres(a5)

	lea	taglist(a5),a0
	move.l	#VTAG_SPRITERESN_SET,(a0)+
	move.l	#SPRITERESN_70NS,(a0)

	move.l	wbscreen(a5),a0
	move.l	sc_ViewPort+vp_ColorMap(a0),a0
	lea	taglist(a5),a1
	jsr	_LVOVideoControl(a6)

	move.l	wbscreen(a5),a0
	move.l	_IntuitionBase(a5),a6
	jsr	_LVOMakeScreen(a6)
	jsr	_LVORethinkDisplay(a6)

.error:	rts


; ***************************************************************************
; main() - May or may not rts to clean up.
; ***************************************************************************

Main:
	bsr	GetZoomOut

	clr.b	TRIG_TEXT(a5)
	clr.b	TRIG_DOEFF(a5)
	move.l	#4,TRIG_ANIM(a5)			; show anim 1

.loop:	tst.l	TRIG_ANIM(a5)			; clear when finished
	bne.b	.loop

	moveq	#46,d3
	moveq	#46,d4
	moveq	#45-1,d7
.lh2:	move.l	$004(a6),d2
	and.l	#$1ff00,d2
	cmp.l	#$8a00,d2
	bne.b	.lh2
	move.w	d3,d0
	move.w	d4,d1
	bsr	CustomPaste
	addq.w	#1,d3
	dbra	d7,.lh2

	lea	testtext(pc),a0
	move.l	a0,TEXT_PTR(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.b	#1,TRIG_DOEFF(a5)			; scroller

	bsr	GetCubeRot


.loop2:	tst.b	TRIG_TEXT(a5)
	bne.b	.loop2

	clr.b	TRIG_DOEFF(a5)

	moveq	#46,d3
	moveq	#0,d4
	moveq	#45-1,d7
.hey:	move.w	d3,d0
	move.w	d4,d1
	bsr	CustomPaste
.lh3:	move.l	$004(a6),d2
	and.l	#$1ff00,d2
	cmp.l	#$8a00,d2
	bne.b	.lh3
	addq.w	#1,d4
	dbra	d7,.hey


	move.l	#8,TRIG_ANIM(a5)			; show anim 2

.loop3:	tst.l	TRIG_ANIM(a5)			; clear when finished
	bne.b	.loop3

	lea	testtext2(pc),a0
	move.l	a0,TEXT_PTR(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#12,TRIG_ANIM(a5)			; anim 3 - looping

.loop4:	tst.b	TRIG_TEXT(a5)
	bne.b	.loop4

	clr.l	TRIG_ANIM(a5)
	clr.w	CTR_FRAME(a5)

	move.b	#1,TRIG_DOWIPEBL(a5)
.loop41:	tst.b	TRIG_DOWIPEBL(a5)
	bne.b	.loop41

	lea	testtext3(pc),a0
	move.l	a0,TEXT_PTR(a5)
	move.b	#1,TRIG_TEXT(a5)

	movea.l	hugebuffer(a5),a0
	moveq	#0,d0
	bsr	FillFull

	movea.l	hugebuffer(a5),a2

	moveq	#3-1,d5
.loopz:	lea	logobuffer(a5),a3


	moveq	#30-1,d6
.loopy:
	move.l	$004(a6),d2
	and.l	#$1ff00,d2
	cmp.l	#$8a00,d2
	bne.b	.loopy

	move.w	#92-1,d7
.loopx:	move.w	(a3)+,(a2)+
	dbra	d7,.loopx

	movea.l	hugebuffer(a5),a0
	bsr	DPasteFull

	dbra	d6,.loopy

	adda.w	#92*2,a2

	dbra	d5,.loopz


	move.b	#2,TRIG_DOEFF(a5)			; stupid eff.

	bsr	GetRotZoom

.loop5:	tst.b	TRIG_TEXT(a5)
	bne.b	.loop5

	clr.b	TRIG_DOEFF(a5)

	move.b	#1,TRIG_DOWIPEBL(a5)
.loop6:	tst.b	TRIG_DOWIPEBL(a5)
	bne.b	.loop6

	lea	testtext4(pc),a0
	move.l	a0,TEXT_PTR(a5)
	move.b	#1,TRIG_TEXT(a5)
	move.l	#16,TRIG_ANIM(a5)			; anim 4 - looping

.loop7:	tst.b	TRIG_TEXT(a5)
	bne.b	.loop7

	clr.l	TRIG_ANIM(a5)
	clr.w	CTR_FRAME(a5)


	bra	QuitNice



Init:
	lea	animtbl(a5),a0
	lea	anim1(pc),a1
	move.l	a1,(a0)+
	lea	anim2(pc),a1
	move.l	a1,(a0)+
	lea	anim3(pc),a1
	move.l	a1,(a0)+
	lea	anim4(pc),a1
	move.l	a1,(a0)+

	lea	logo(pc),a0
	lea	logobuffer(a5),a1
	bsr	PChunky2Chunky

	lea	picture(pc),a0
	lea	framebuffer(a5),a1
	bsr	PChunky2Chunky

	move.w	#46,xoffset(a5)
	move.w	#1,adder(a5)

	; *** set up copperlist
_icopper:
	move.l	copperlist(a5),a4
	lea	static_copper(pc),a3

.loop:	move.l	(a3)+,(a4)+
	cmp.l	#-1,(a3)
	bne.b	.loop


	; now at block!
p2:	lea	chunkytable(a5),a2
	moveq	#$2c,d0

	moveq	#(COPPERLINES+2)/2-1,d6			; 2 lines for stopping cols

 
.outloop:
	move.l	#$000fff00,(a4)+
	move.b	d0,-4(a4)

	movea.l	a4,a3
	addq.w	#6,a3
	move.l	a3,(a2)+				; save in chunkytable

	move.l	#$0106a000,(a4)+
	move.l	#$0106c000,128(a4)
	move.l	#$0106e000,256+4(a4)

	moveq	#28-1,d7
	move.l	#$01800000,d5
.loop:	move.l	d5,(a4)+
	move.l	d5,128+4-4(a4)
	move.l	d5,256+8-4(a4)
	add.l	#$00020000,d5
	dbra	d7,.loop

	moveq	#4-1,d7
.loop2:	move.l	d5,(a4)+
	move.l	d5,128+4-4(a4)
	add.l	#$00020000,d5
	dbra	d7,.loop2

	add.l	#256-8,a4
	addq.w	#2,d0


	move.l	#$000fff00,(a4)+
	move.b	d0,-4(a4)

	movea.l	a4,a3
	addq.w	#6,a3
	move.l	a3,(a2)+				; save in chunkytable

	move.l	#$01064000,(a4)+
	move.l	#$01066000,128(a4)
	move.l	#$01068000,256+4(a4)

	moveq	#28-1,d7
	move.l	#$01800000,d5
.loop3:	move.l	d5,(a4)+
	move.l	d5,128+4-4(a4)
	move.l	d5,256+8-4(a4)
	add.l	#$00020000,d5
	dbra	d7,.loop3

	moveq	#4-1,d7
.loop4:	move.l	d5,(a4)+
	move.l	d5,128+4-4(a4)
	add.l	#$00020000,d5
	dbra	d7,.loop4

	add.l	#256-8,a4

	addq.w	#2,d0



	dbra	d6,.outloop

	; patch in end
	lea	static_endcopper(pc),a3

.loop21:	move.l	(a3)+,(a4)+
	cmp.l	#-1,(a3)
	bne.b	.loop21







	; *** set up pointers

p3:	move.l	screenbuffer(a5),a0

	move.l	copperlist(a5),a4
	lea	bplptrs(a4),a4
	moveq	#8-1,d7

.loop:	move.l	a0,d0

	move.w	d0,6(a4)
	swap	d0
	move.w	d0,2(a4)

	add.w	#40,a0
	addq.w	#8,a4

	dbra	d7,.loop


	; *** draw background pattern
	move.l	hugebuffer(a5),a0
	moveq	#64,d0
	bsr	PreCalcCHackLine

	move.l	hugebuffer(a5),a0
	add.w	#6*4*8,a0
	move.w	#160,d0
	bsr	PreCalcCHackLine

	move.l	screenbuffer(a5),a1
	moveq	#200/4-1,d7
.cpylineloop:
	bsr	CpyLine1
	add.w	#320,a1
	bsr	CpyLine1
	add.w	#320,a1
	bsr	CpyLine2
	add.w	#320,a1
	bsr	CpyLine2
	add.w	#320,a1
	dbra	d7,.cpylineloop
	rts



;a1=start of screen line
CpyLine1:
	movem.l	d0-a6,-(SP)
	move.l	hugebuffer(a5),a0
	moveq	#8-1,d7
	bra.B	CpyLineLoop
CpyLine2:
	movem.l	d0-a6,-(SP)
	move.l	hugebuffer(a5),a0
	add.w	#6*4*8,a0
	moveq	#8-1,d7
CpyLineLoop:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	add.w	#320/8-6*4,a1
	dbra	d7,CpyLineLoop
	movem.l	(SP)+,d0-a6
	rts


; d0 = StartColor
; a0 = LineStart

PreCalcCHackLine:
	moveq	#6-1,d7
.yeah:
	moveq	#32-1,d6
.longLoop:
	moveq	#8-1,d5
.byteLoop:
	rol.b	#1,d0
	move.b	d0,d1
	and.l	#1,d1
	lsl.l	d6,d1
	moveq	#6*4,d4
	mulu	d5,d4
	or.l	d1,(a0,d4.w)
	lsr.l	#1,d1
	or.l	d1,(a0,d4.w)
	dbra	d5,.byteLoop

	addq.w	#1,d0
	subq.l	#2,d6
	bge	.longLoop

	addq.l	#4,a0
	dbra	d7,.yeah
	clr.b	-1+(0*6*4)(a0)
	clr.b	-1+(1*6*4)(a0)
	clr.b	-1+(2*6*4)(a0)
	clr.b	-1+(3*6*4)(a0)
	clr.b	-1+(4*6*4)(a0)
	clr.b	-1+(5*6*4)(a0)
	clr.b	-1+(6*6*4)(a0)
	clr.b	-1+(7*6*4)(a0)
	rts




; ***********************************************
; GetZoomOut

GetZoomOut:
	movea.l	hugebuffer(a5),a3

	moveq	#90-1,d5
	move.l	#4,d7

.lh:	lea	framebuffer(a5),a0
	movea.l	a3,a1
	move.l	d7,d0
	moveq	#1,d1
	bsr	ScaleFull

	addq.w	#2,d7
	adda.w	#92*92*2,a3

	dbra	d5,.lh

	moveq	#1-1,d6

	lea	_custom,a6

	rts


; ***********************************************
; GetCubeRot

GetCubeRot:
	move.w	#0,d4
	move.w	#0,d5
	move.w	#91,d6
	move.w	#0,d7

	movea.l	hugebuffer(a5),a4
	move.b	#46,cnt(a5)

.aloop:

	movea.l	a4,a0
	move.w	#$0000,d0
	bsr	FillFull

	move.w	d4,d0
	move.w	d5,d1
	move.w	d6,d2
	move.w	d7,d3


	move.w	d0,-(a7)
	bsr	GetWhere
	move.w	(a7)+,d0
	movea.l	a4,a0
	bsr	TMap


	move.w	d6,d0
	move.w	d7,d1

	moveq	#92,d2
	sub.w	d4,d2

	moveq	#46,d3
	sub.w	d5,d3


	move.w	d0,-(a7)
	bsr	GetWhere2
	move.w	(a7)+,d0
	movea.l	a4,a0
	bsr	TMap

	addq.w	#1,d5
	subq.w	#2,d6

	add.w	#92*92*2,a4

	subq.b	#1,cnt(a5)
	bne.b	.aloop

	rts


; d0/d1/d2/d3 = x1/y1/x2/y2
; calcs tables needed for texture mapping
; put in sizetbl and scalebuf

GetWhere:
	movem.l	a2-a4/a6/d2-d7,-(a7)

	; 92-y1*2 = stop x
	; 92-y2*2 = start x
	; x2-x1   = steps (for horiz)

	cmp.w	#46,d1
	blt.b	.hey

	moveq	#92,d4
	sub.w	d1,d4
	move.w	d4,d1


.hey:	cmp.w	#46,d3
	blt.b	.hey2

	moveq	#92,d4
	sub.w	d3,d4
	move.w	d4,d3


.hey2:	add.w	d1,d1
	add.w	d3,d3

	sub.w	d0,d2				; x1-x2 d2 = steps

	move.w	d2,d5


	moveq	#92,d4
	sub.w	d1,d4				; 92-y1*2 d1 = stop x
	move.w	d4,d0

	moveq	#92,d4
	sub.w	d3,d4
	move.w	d4,d1				; d0 = start x

	move.l	d1,d4

	lsl.w	#8,d0
	lsl.w	#8,d4

	sub.w	d0,d4


	tst.w	d2
	beq.b	.hey3

	divu	d2,d4				; (d4) = (sx-stx)/steps

.hey3:	lea	sizetbl(a5),a0

.lp:	move.w	d0,d3
	lsr.w	#8,d3
	move.b	d3,(a0)+
	add.w	d4,d0
	dbra	d2,.lp

	move.b	d1,-(a0)
	move.b	#-1,(a0)

	; do this frame
	moveq	#0,d0
	move.w	d5,d0
	lea	scalebuf(a5),a0			; a0 = whichlines
	bsr	GetScale

	movem.l	(a7)+,a2-a4/a6/d2-d7
	rts


; d0/d1/d2/d3 = x1/y1/x2/y2
; y1 > y2

GetWhere2:
	movem.l	a2-a4/a6/d2-d7,-(a7)

	; 92-y1*2 = stop x
	; 92-y2*2 = start x
	; x2-x1   = steps (for horiz)

	cmp.w	#46,d1
	blt.b	.hey

	moveq	#92,d4
	sub.w	d1,d4
	move.w	d4,d1


.hey:	cmp.w	#46,d3
	blt.b	.hey2

	moveq	#92,d4
	sub.w	d3,d4
	move.w	d4,d3


.hey2:	add.w	d1,d1
	add.w	d3,d3

	sub.w	d0,d2				; x1-x2 d2 = steps

	move.w	d2,d5


	moveq	#92,d4
	sub.w	d1,d4				; 92-y1*2 d1 = stop x
	move.w	d4,d1

	moveq	#92,d4
	sub.w	d3,d4
	move.w	d4,d0				; d0 = start x

	move.l	d1,d4

	lsl.w	#8,d0
	lsl.w	#8,d4

	sub.w	d0,d4

	tst.w	d2
	beq.b	.hey3

	divu	d2,d4				; (d4) = (sx-stx)/steps

.hey3:	lea	sizetbl+1(a5),a0
	add.w	d2,a0
	move.b	#-1,-(a0)

.lp:	move.w	d0,d3
	lsr.w	#8,d3
	move.b	d3,-(a0)
	add.w	d4,d0
	dbra	d2,.lp


	; do this frame
	moveq	#0,d0
	move.w	d5,d0
	lea	scalebuf(a5),a0			; a0 = whichlines
	bsr	GetScale

	movem.l	(a7)+,a2-a4/a6/d2-d7
	rts






; d0 = dest. size
GetScale:
	movem.l	d0-d3/a0,-(a7)
	and.l	#$0000ffff,d0

	move.l	#184*256,d1

	tst.w	d0
	beq.b	.doneline
	divu	d0,d1				; ctr = (92*256)/i
	and.l	#$0000ffff,d1
	moveq	#-1,d3				; ctot

.loop2:	add.l	d1,d3

;	and.l	#$000fffff,d3
	cmp.l	#184*256,d3
	bgt.b	.doneline

	move.l	d3,d2
	lsr.l	#8,d2
	move.b	d2,(a0)+

	bra.b	.loop2

.doneline:
	move.b	#-1,(a0)
	movem.l	(a7)+,d0-d3/a0
	rts





; scalebuf and sizetbl must be initialized
; d0 = x start

TMap:
	movem.l	a2-a4/a6/d2-d7,-(a7)

	movea.l	a0,a4
	move.l	a0,-(a7)

	move.w	d0,d3
	add.w	d3,d3

	lea	scalebuf(a5),a0
	lea	sizetbl(a5),a1

	moveq	#0,d7

	; do each line
.loop:	moveq	#0,d6
	move.b	(a0)+,d6				; next line to scale'n plot

	cmp.b	#-1,d6
	beq.b	mlldone

	lea	framebuffer(a5),a6
	adda.w	d6,a6
	adda.w	d6,a6				; a7 = ptr to vert line in pic

	moveq	#0,d4
	move.b	(a1)+,d4				; d4 = dest size of line

	move.w	d4,d0
	move.l	a0,-(a7)
	lea	scalebuf2(a5),a0
	movea.l	a0,a3
	bsr	GetScale				; fill in scalebuf
	movea.l	(a7)+,a0

	moveq	#92,d0
	sub.w	d4,d0
	lsr.w	#1,d0
	mulu	#92*2,d0				; d0 = skip

	move.l	(a7),a4
	add.w	d7,d0
	add.w	d7,d0
	add.w	d3,d0
	adda.w	d0,a4				; a4 now at right pos, plot it!


	; all done, draw one line!
.loop2:	moveq	#0,d0
	move.b	(a3)+,d0				; next coord

	cmp.b	#-1,d0
	beq.b	.next

	movea.l	a6,a2

	mulu	#92*2*2,d0
	adda.l	d0,a2				; hmm?

	move.w	(a2),(a4)

	adda.w	#92*2,a4

	bra.b	.loop2

.next:	addq.w	#1,d7
	bra.b	.loop

mlldone:	addq.w	#4,a7
	movem.l	(a7)+,a2-a4/a6/d2-d7
	rts


; ***********************************************
; GetRotZoom

GetRotZoom:

	moveq	#45-1,d7
	moveq	#0,d6
	moveq	#100,d5
	movea.l	hugebuffer(a5),a4

testit:	lea	framebuffer(a5),a0
	lea	framebuffer(a5),a1
	add.l	#184*184*2,a1
	move.l	d6,d0
	bsr	ZRotateFull

	addq.w	#1,currfr(a5)

	lea	framebuffer(a5),a0
	add.l	#184*184*2,a0
	movea.l	a4,a1
	move.l	d5,d0
	moveq	#1,d1
	bsr	ScaleFull

	adda.w	#92*92*2,a4
	addq.w	#4,d6
	addq.w	#3,d5
	dbra	d7,testit

	moveq	#45-1,d7
	move.l	#180,d6
	move.l	#235,d5

testit2:	lea	framebuffer(a5),a0
	lea	framebuffer(a5),a1
	add.l	#184*184*2,a1
	move.l	d6,d0
	bsr	ZRotateFull

	addq.w	#1,currfr(a5)

	lea	framebuffer(a5),a0
	add.l	#184*184*2,a0
	movea.l	a4,a1
	move.l	d5,d0
	moveq	#1,d1
	bsr	ScaleFull

	addq.w	#4,d6
	subq.w	#3,d5
	adda.w	#92*92*2,a4
	dbra	d7,testit2

	rts



; ***********************************************
; ZRotateFull( src, dest, deg )
; inputs: d0 - degrees to rotate
;         a0 - chunky pic to rotate
;         a1 - dest buffer (184*184 NOTE!!)
; OPTIMIZE!
; ***********************************************


ZRotateFull:
	movem.l	a3-a4/a6/d2-d7,-(a7)

	adda.l	#184*184*2,a0
	move.l	d0,d2

	lea	sinus(pc),a4
	lea	cosinus(pc),a6


	; executed 184*184 times

	move.w	#184-1,d4

.loop2:	move.w	#184-1,d7

.loop:	move.w	d4,d0
	move.w	d7,d1

	sub.w	#92,d0
	sub.w	#92,d1

	; :-)
	move.w	d4,a3

	move.w	(a4,d2.w*2),d3		; d3 = sin d2
	move.w	(a6,d2.w*2),d4		; d4 = cos d2

	move.w	d3,d5
	move.w	d4,d6

	muls	d1,d3			; d3 = sin d2 y
	muls	d1,d4			; d4 = cos d2 y

	muls	d0,d5			; d5 = sin d2 x
	muls	d6,d0			; d6 = cos d2 x

;	move.w	d6,d0
	add.w	d3,d0			; d0 = cos d2 x + sin d2 y
	sub.w	d5,d4			; d4 = - sin d2 x + cos d2 y

	asr.w	#8,d0
	asr.w	#8,d4

	and.l	#$0000ffff,d0
	and.l	#$0000ffff,d4

	add.w	#92,d0
	blt.b	.nextit
	cmp.w	#184,d0
	bge.b	.nextit

	add.w	#92,d4
	blt.b	.nextit
	cmp.w	#184,d4
	bge.b	.nextit

	; valid point
	mulu	#184,d4
	add.l	d0,d4
	move.w	(a0),(a1,d4.l*2)

	cmp.w	#184-1,d0
	beq.b	.nextit
	move.w	(a0),2(a1,d4.l*2)

.nextit:	move.w	a3,d4
	subq.w	#2,a0
	dbra	d7,.loop

	dbra	d4,.loop2

	movem.l	(a7)+,a3-a4/a6/d2-d7
	rts


; ***********************************************
; ScaleFull( src, dest, destsize )
; inputs: a0 - source map
;         a1 - destination map
;         d0 - destsize
;         d1 - flags ( 1 = center )
; ***********************************************

ScaleFull:
	tst.w	d0
	bne.b	.hey
	rts

.hey:	movem.l	a2-a4/a6/d2-d7,-(a7)

	movea.l	a0,a4				; a4 = backup src

	moveq	#0,d3
	moveq	#0,d2

	move.w	d0,d5

;	subq.w	#1,d0
	lea	scalebuf(a5),a0
	movea.l	a0,a2
	bsr	GetScale

	movea.l	a2,a3
	movea.l	a3,a6

	cmp.w	#92,d5
	bge.b	.scalebig

	; *** scale picture down
	tst.b	d1
	beq.b	.nocenter

	; center picture, calc other offsets
	moveq	#92,d4
	sub.w	d5,d4
	move.w	d4,d6				; backup
	lsr.w	#1,d4
	mulu	#92*2,d4
	adda.w	d4,a1

	lsr.w	#1,d6
	add.w	d6,d6
	adda.w	d6,a1

.nocenter:
	moveq	#92,d4
	sub.w	d5,d4
	lsl.w	#1,d4				; d4 = modulo

	subq.w	#1,d5				; counters
	move.w	d5,d1
	move.w	d5,d6

.next:	moveq	#0,d2
	move.b	(a2)+,d2

	mulu	#184*2,d2
	movea.l	a4,a0
	adda.l	d2,a0

	movea.l	a6,a3

	; process this line
.loop:	move.b	(a3)+,d3
	move.w	(a0,d3.w*2),(a1)+
	dbra	d5,.loop

.dline:	adda.w	d4,a1
	move.w	d1,d5
	dbra	d6,.next

	bra.b	.alldone

	; *** size is >=92, easy part :-)
.scalebig:
	tst.b	d1
	beq.b	.nocenter2

	; center picture, calc other offsets
	sub.w	#92,d5
	lsr.w	#1,d5

	adda.w	d5,a6
	adda.w	d5,a2

.nocenter2:
	moveq	#92-1,d6

.next2:	moveq	#0,d2
	move.b	(a2)+,d2

	mulu.w	#184*2,d2
	movea.l	a4,a0
	adda.l	d2,a0

	movea.l	a6,a3

	; process this line
	moveq	#92-1,d7
.loop4:	move.b	(a3)+,d3
	move.w	(a0,d3.w*2),(a1)+
	dbra	d7,.loop4

	dbra	d6,.next2

	; restore regs, exit
.alldone:
	movem.l	(a7)+,a2-a4/a6/d2-d7
	rts









; ***********************************************
; Plot( x, y )
; Plots a point in a chunky map.
; inputs: a0 - source map
;         d0 - x
;         d1 - y
;         d2 - color
; ***********************************************

Plot:
	mulu	#92,d1
	add.w	d0,d1
	move.w	d2,(a0,d1.w*2)
	rts




; ***********************************************
; FillFull( src, color rgb )
; Fills entire chunky buffer with color.
; is centered.
; inputs: a0 - source map
;         d0 - color
; ***********************************************

FillFull:
	move.w	#92*92-1,d1
.loop:	move.w	d0,(a0)+
	dbra	d1,.loop
	rts

; ***********************************************
; FilledBox( dest Buffer, x, y, sizex, sizey, color )
; Fills a box at pos x,y->x+sizex,y+sizey with
; color.
; inputs: a0 - source map
;         d0 - x
;         d1 - y
;         d2 - sizex
;         d3 - sizey
;         d4 - color
; ***********************************************

FilledBox:
	movem.l	d2/d3/d5/d7,-(a7)

	moveq	#91,d7
	sub.w	d2,d7
	add.w	d7,d7				; d7 = "modulo"

	mulu	#92*2,d1
	add.w	d0,d0
	add.w	d0,d1
	add.w	d1,a0				; a0 = u/l corner

	move.l	d2,d5				; d5 = saved sizex counter

.loop:
.loop2:	move.w	d4,(a0)+
	dbra	d2,.loop2

	add.w	d7,a0
	move.l	d5,d2

	dbra	d3,.loop

	movem.l	(a7)+,d2/d3/d5/d7
	rts



CustomPaste:
	lea	framebuffer(a5),a0
	adda.w	d0,a0				; horiz offset
	adda.w	d0,a0

	mulu	#184*2,d1
	adda.l	d1,a0

	moveq	#92-1,d0				; 92 y lines
	move.l	chunkytable(a5),a1		; get first entry!

.loop:	move.w	(a0)+,(a1)
	move.w	(a0)+,4(a1)
	move.w	(a0)+,8(a1)
	move.w	(a0)+,12(a1)
	move.w	(a0)+,16(a1)
	move.w	(a0)+,20(a1)
	move.w	(a0)+,24(a1)
	move.w	(a0)+,28(a1)
	move.w	(a0)+,32(a1)
	move.w	(a0)+,36(a1)
	move.w	(a0)+,40(a1)
	move.w	(a0)+,44(a1)
	move.w	(a0)+,48(a1)
	move.w	(a0)+,52(a1)
	move.w	(a0)+,56(a1)
	move.w	(a0)+,60(a1)
	move.w	(a0)+,64(a1)
	move.w	(a0)+,68(a1)
	move.w	(a0)+,72(a1)
	move.w	(a0)+,76(a1)
	move.w	(a0)+,80(a1)
	move.w	(a0)+,84(a1)
	move.w	(a0)+,88(a1)
	move.w	(a0)+,92(a1)
	move.w	(a0)+,96(a1)
	move.w	(a0)+,100(a1)
	move.w	(a0)+,104(a1)
	move.w	(a0)+,108(a1)
	move.w	(a0)+,112(a1)
	move.w	(a0)+,116(a1)
	move.w	(a0)+,120(a1)
	move.w	(a0)+,124(a1)

	move.w	(a0)+,132(a1)
	move.w	(a0)+,136(a1)
	move.w	(a0)+,140(a1)
	move.w	(a0)+,144(a1)
	move.w	(a0)+,148(a1)
	move.w	(a0)+,152(a1)
	move.w	(a0)+,156(a1)
	move.w	(a0)+,160(a1)
	move.w	(a0)+,164(a1)
	move.w	(a0)+,168(a1)
	move.w	(a0)+,172(a1)
	move.w	(a0)+,176(a1)
	move.w	(a0)+,180(a1)
	move.w	(a0)+,184(a1)
	move.w	(a0)+,188(a1)
	move.w	(a0)+,192(a1)
	move.w	(a0)+,196(a1)
	move.w	(a0)+,200(a1)
	move.w	(a0)+,204(a1)
	move.w	(a0)+,208(a1)
	move.w	(a0)+,212(a1)
	move.w	(a0)+,216(a1)
	move.w	(a0)+,220(a1)
	move.w	(a0)+,224(a1)
	move.w	(a0)+,228(a1)
	move.w	(a0)+,232(a1)
	move.w	(a0)+,236(a1)
	move.w	(a0)+,240(a1)
	move.w	(a0)+,244(a1)
	move.w	(a0)+,248(a1)
	move.w	(a0)+,252(a1)
	move.w	(a0)+,256(a1)

	move.w	(a0)+,264(a1)
	move.w	(a0)+,268(a1)
	move.w	(a0)+,272(a1)
	move.w	(a0)+,276(a1)
	move.w	(a0)+,280(a1)
	move.w	(a0)+,284(a1)
	move.w	(a0)+,288(a1)
	move.w	(a0)+,292(a1)
	move.w	(a0)+,296(a1)
	move.w	(a0)+,300(a1)
	move.w	(a0)+,304(a1)
	move.w	(a0)+,308(a1)
	move.w	(a0)+,312(a1)
	move.w	(a0)+,316(a1)
	move.w	(a0)+,320(a1)
	move.w	(a0)+,324(a1)
	move.w	(a0)+,328(a1)
	move.w	(a0)+,332(a1)
	move.w	(a0)+,336(a1)
	move.w	(a0)+,340(a1)
	move.w	(a0)+,344(a1)
	move.w	(a0)+,348(a1)
	move.w	(a0)+,352(a1)
	move.w	(a0)+,356(a1)
	move.w	(a0)+,360(a1)
	move.w	(a0)+,364(a1)
	move.w	(a0)+,368(a1)
	move.w	(a0)+,372(a1)

	adda.w	#96*4,a1				; hmm

	adda.w	#92*2,a0

	dbra	d0,.loop


	rts


; ***********************************************
; DPasteFull
; Pastes a chunky style 96x96 bitmap on the screen
; without mask.
; Heavily optimized - no longer uses other primitives
; inputs: a0 - ptr to chunky map
; ***********************************************

DPasteFull:
	moveq	#92-1,d0				; 96 y lines
	move.l	chunkytable(a5),a1		; get first entry!

.loop:	move.w	(a0)+,(a1)
	move.w	(a0)+,4(a1)
	move.w	(a0)+,8(a1)
	move.w	(a0)+,12(a1)
	move.w	(a0)+,16(a1)
	move.w	(a0)+,20(a1)
	move.w	(a0)+,24(a1)
	move.w	(a0)+,28(a1)
	move.w	(a0)+,32(a1)
	move.w	(a0)+,36(a1)
	move.w	(a0)+,40(a1)
	move.w	(a0)+,44(a1)
	move.w	(a0)+,48(a1)
	move.w	(a0)+,52(a1)
	move.w	(a0)+,56(a1)
	move.w	(a0)+,60(a1)
	move.w	(a0)+,64(a1)
	move.w	(a0)+,68(a1)
	move.w	(a0)+,72(a1)
	move.w	(a0)+,76(a1)
	move.w	(a0)+,80(a1)
	move.w	(a0)+,84(a1)
	move.w	(a0)+,88(a1)
	move.w	(a0)+,92(a1)
	move.w	(a0)+,96(a1)
	move.w	(a0)+,100(a1)
	move.w	(a0)+,104(a1)
	move.w	(a0)+,108(a1)
	move.w	(a0)+,112(a1)
	move.w	(a0)+,116(a1)
	move.w	(a0)+,120(a1)
	move.w	(a0)+,124(a1)

	move.w	(a0)+,132(a1)
	move.w	(a0)+,136(a1)
	move.w	(a0)+,140(a1)
	move.w	(a0)+,144(a1)
	move.w	(a0)+,148(a1)
	move.w	(a0)+,152(a1)
	move.w	(a0)+,156(a1)
	move.w	(a0)+,160(a1)
	move.w	(a0)+,164(a1)
	move.w	(a0)+,168(a1)
	move.w	(a0)+,172(a1)
	move.w	(a0)+,176(a1)
	move.w	(a0)+,180(a1)
	move.w	(a0)+,184(a1)
	move.w	(a0)+,188(a1)
	move.w	(a0)+,192(a1)
	move.w	(a0)+,196(a1)
	move.w	(a0)+,200(a1)
	move.w	(a0)+,204(a1)
	move.w	(a0)+,208(a1)
	move.w	(a0)+,212(a1)
	move.w	(a0)+,216(a1)
	move.w	(a0)+,220(a1)
	move.w	(a0)+,224(a1)
	move.w	(a0)+,228(a1)
	move.w	(a0)+,232(a1)
	move.w	(a0)+,236(a1)
	move.w	(a0)+,240(a1)
	move.w	(a0)+,244(a1)
	move.w	(a0)+,248(a1)
	move.w	(a0)+,252(a1)
	move.w	(a0)+,256(a1)

	move.w	(a0)+,264(a1)
	move.w	(a0)+,268(a1)
	move.w	(a0)+,272(a1)
	move.w	(a0)+,276(a1)
	move.w	(a0)+,280(a1)
	move.w	(a0)+,284(a1)
	move.w	(a0)+,288(a1)
	move.w	(a0)+,292(a1)
	move.w	(a0)+,296(a1)
	move.w	(a0)+,300(a1)
	move.w	(a0)+,304(a1)
	move.w	(a0)+,308(a1)
	move.w	(a0)+,312(a1)
	move.w	(a0)+,316(a1)
	move.w	(a0)+,320(a1)
	move.w	(a0)+,324(a1)
	move.w	(a0)+,328(a1)
	move.w	(a0)+,332(a1)
	move.w	(a0)+,336(a1)
	move.w	(a0)+,340(a1)
	move.w	(a0)+,344(a1)
	move.w	(a0)+,348(a1)
	move.w	(a0)+,352(a1)
	move.w	(a0)+,356(a1)
	move.w	(a0)+,360(a1)
	move.w	(a0)+,364(a1)
	move.w	(a0)+,368(a1)
	move.w	(a0)+,372(a1)

	add.w	#96*4,a1

	dbra	d0,.loop

	rts

; ***********************************************
; DFillFull( color )
; Fills entire screen with a color.
; inputs: d0 - color
; ***********************************************

DFillFull:
	moveq	#92-1,d1				; 96 y lines
	move.l	chunkytable(a5),a1		; get first entry!

.loop:
	move.w	d0,(a1)
	move.w	d0,4(a1)
	move.w	d0,8(a1)
	move.w	d0,12(a1)
	move.w	d0,16(a1)
	move.w	d0,20(a1)
	move.w	d0,24(a1)
	move.w	d0,28(a1)
	move.w	d0,32(a1)
	move.w	d0,36(a1)
	move.w	d0,40(a1)
	move.w	d0,44(a1)
	move.w	d0,48(a1)
	move.w	d0,52(a1)
	move.w	d0,56(a1)
	move.w	d0,60(a1)
	move.w	d0,64(a1)
	move.w	d0,68(a1)
	move.w	d0,72(a1)
	move.w	d0,76(a1)
	move.w	d0,80(a1)
	move.w	d0,84(a1)
	move.w	d0,88(a1)
	move.w	d0,92(a1)
	move.w	d0,96(a1)
	move.w	d0,100(a1)
	move.w	d0,104(a1)
	move.w	d0,108(a1)
	move.w	d0,112(a1)
	move.w	d0,116(a1)
	move.w	d0,120(a1)
	move.w	d0,124(a1)

	move.w	d0,132(a1)
	move.w	d0,136(a1)
	move.w	d0,140(a1)
	move.w	d0,144(a1)
	move.w	d0,148(a1)
	move.w	d0,152(a1)
	move.w	d0,156(a1)
	move.w	d0,160(a1)
	move.w	d0,164(a1)
	move.w	d0,168(a1)
	move.w	d0,172(a1)
	move.w	d0,176(a1)
	move.w	d0,180(a1)
	move.w	d0,184(a1)
	move.w	d0,188(a1)
	move.w	d0,192(a1)
	move.w	d0,196(a1)
	move.w	d0,200(a1)
	move.w	d0,204(a1)
	move.w	d0,208(a1)
	move.w	d0,212(a1)
	move.w	d0,216(a1)
	move.w	d0,220(a1)
	move.w	d0,224(a1)
	move.w	d0,228(a1)
	move.w	d0,232(a1)
	move.w	d0,236(a1)
	move.w	d0,240(a1)
	move.w	d0,244(a1)
	move.w	d0,248(a1)
	move.w	d0,252(a1)
	move.w	d0,256(a1)

	move.w	d0,264(a1)
	move.w	d0,268(a1)
	move.w	d0,272(a1)
	move.w	d0,276(a1)
	move.w	d0,280(a1)
	move.w	d0,284(a1)
	move.w	d0,288(a1)
	move.w	d0,292(a1)
	move.w	d0,296(a1)
	move.w	d0,300(a1)
	move.w	d0,304(a1)
	move.w	d0,308(a1)
	move.w	d0,312(a1)
	move.w	d0,316(a1)
	move.w	d0,320(a1)
	move.w	d0,324(a1)
	move.w	d0,328(a1)
	move.w	d0,332(a1)
	move.w	d0,336(a1)
	move.w	d0,340(a1)
	move.w	d0,344(a1)
	move.w	d0,348(a1)
	move.w	d0,352(a1)
	move.w	d0,356(a1)
	move.w	d0,360(a1)
	move.w	d0,364(a1)
	move.w	d0,368(a1)
	move.w	d0,372(a1)

	add.w	#96*4,a1
	dbra	d1,.loop

	rts


; ***********************************************
; DPlot( x, y, color )
; Plots a point on the screen.
; inputs: d0 - x
;         d1 - y
;         d2 - color
; ***********************************************

DPlot:
	lea	chunkytable(a5),a0
	movea.l	(a0,d1.w*4),a1

	lea	offsets(pc),a0
	move.w	(a0,d0.w*2),d1

	move.w	d2,(a1,d1.w)

	rts

	;        0 1 2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24  25  26  27  28  29  30  31  
offsets:	dc.w	0,4,8,12,16,20,24,28,32,36,40,44,48,52,56,60,64,68,72,76,80,84,88,92,96,100,104,108,112,116,120,124

	;         32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47  48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	dc.w	132,136,140,144,148,152,156,160,164,168,172,176,180,184,188,192,196,200,204,208,212,216,220,224,228,232,236,240,244,248,252,256

	;         64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79  80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	dc.w	264,268,272,276,280,284,288,292,296,300,304,308,312,316,320,324,328,332,336,340,344,348,352,356,360,364,368,372





; ***********************************************
; PChunky2Chunky
; Converts a picture in PChunky format to normal
; chunky format.
; PChunky = rrrrggggbbbbrrrrggggbbbbrrrrggggbbbb...
; Chunky  = 0000rrrrggggbbbb0000rrrrggggbbbb...
; ***********************************************

PChunky2Chunky:
	move.w	#(4232*4)-1,d4		; 24 bits pr time
	moveq	#0,d5

.loop:
	move.l	d5,d0
	move.l	d5,d1
	move.l	d5,d2
	move.l	d5,d3

	; process 24 bits at a time = rgb/rgb
	move.b	(a0)+,d0			; d0 = 00rg
	move.b	(a0)+,d1			; d1 = 00br
	move.b	(a0)+,d2			; d2 = 00gb

	lsl.w	#4,d0			; d0 = 0rg0 (1)
	move.b	d1,d3
	lsr.b	#4,d3			; d3 = 000b (1)
	or.b	d3,d0			; d0 = 0rgb (1)

	and.b	#%00001111,d1		; d1 = 000r (2)
	lsl.w	#8,d1			; d1 = 0r00 (2)
	move.b	d2,d1			; d1 = 0rgb (2)

	move.w	d0,(a1)+
	move.w	d1,(a1)+

	dbra	d4,.loop

	rts


sinus:
;**** Shine! sinus wave generation from 0 degrees to 450 degrees.
;**** Total amount of values = 450

	dc.w	0,4,9,13,18,22,27,31
	dc.w	36,40,44,49,53,58,62,66
	dc.w	71,75,79,83,88,92,96,100
	dc.w	104,108,112,116,120,124,128,132
	dc.w	136,139,143,147,150,154,158,161
	dc.w	165,168,171,175,178,181,184,187
	dc.w	190,193,196,199,202,204,207,210
	dc.w	212,215,217,219,222,224,226,228
	dc.w	230,232,234,236,237,239,241,242
	dc.w	243,245,246,247,248,249,250,251
	dc.w	252,253,254,254,255,255,255,256
	dc.w	256,256

cosinus:
	dc.w	256,256,256,256,255,255
	dc.w	255,254,254,253,252,251,250,249
	dc.w	248,247,246,245,243,242,241,239
	dc.w	237,236,234,232,230,228,226,224
	dc.w	222,219,217,215,212,210,207,204
	dc.w	202,199,196,193,190,187,184,181
	dc.w	178,175,171,168,165,161,158,154
	dc.w	150,147,143,139,136,132,128,124
	dc.w	120,116,112,108,104,100,96,92
	dc.w	88,83,79,75,71,66,62,58
	dc.w	53,49,44,40,36,31,27,22
	dc.w	18,13,9,4,0,-4,-8,-13
	dc.w	-17,-22,-26,-31,-35,-40,-44,-48
	dc.w	-53,-57,-61,-66,-70,-74,-79,-83
	dc.w	-87,-91,-95,-100,-104,-108,-112,-116
	dc.w	-120,-124,-127,-131,-135,-139,-143,-146
	dc.w	-150,-154,-157,-161,-164,-167,-171,-174
	dc.w	-177,-181,-184,-187,-190,-193,-196,-198
	dc.w	-201,-204,-207,-209,-212,-214,-217,-219
	dc.w	-221,-223,-226,-228,-230,-232,-233,-235
	dc.w	-237,-238,-240,-242,-243,-244,-246,-247
	dc.w	-248,-249,-250,-251,-252,-252,-253,-254
	dc.w	-254,-255,-255,-255,-255,-255,-256,-255
	dc.w	-255,-255,-255,-255,-254,-254,-253,-252
	dc.w	-252,-251,-250,-249,-248,-247,-246,-244
	dc.w	-243,-242,-240,-238,-237,-235,-233,-232
	dc.w	-230,-228,-226,-223,-221,-219,-217,-214
	dc.w	-212,-209,-207,-204,-201,-198,-196,-193
	dc.w	-190,-187,-184,-181,-177,-174,-171,-167
	dc.w	-164,-161,-157,-154,-150,-146,-143,-139
	dc.w	-135,-131,-128,-124,-120,-116,-112,-108
	dc.w	-104,-100,-95,-91,-87,-83,-79,-74
	dc.w	-70,-66,-61,-57,-53,-48,-44,-40
	dc.w	-35,-31,-26,-22,-17,-13,-8,-4
	dc.w	0,4,9,13,18,22,27,31
	dc.w	36,40,44,49,53,58,62,66
	dc.w	71,75,79,83,88,92,96,100
	dc.w	104,108,112,116,120,124,128,132
	dc.w	136,139,143,147,150,154,158,161
	dc.w	165,168,171,175,178,181,184,187
	dc.w	190,193,196,199,202,204,207,210
	dc.w	212,215,217,219,222,224,226,228
	dc.w	230,232,234,236,237,239,241,242
	dc.w	243,245,246,247,248,249,250,251
	dc.w	252,253,254,254,255,255,255,256
	dc.w	256,256,256

;**** End of Shine! sinus wave generation

GoTable:



;**** Shine! sinus wave generation from 0 degrees to 360 degrees.
;**** Total amount of values = 184

	dc.b	46,48,49,51,52,54,55,57
	dc.b	58,60,61,63,64,65,67,68
	dc.b	69,71,72,73,74,76,77,78
	dc.b	79,80,81,82,83,84,84,85
	dc.b	86,87,87,88,88,89,89,90
	dc.b	90,90,91,91,91,91,91,91
	dc.b	91,91,91,90,90,90,89,89
	dc.b	88,88,87,87,86,85,84,84
	dc.b	83,82,81,80,79,78,77,76
	dc.b	74,73,72,71,69,68,67,65
	dc.b	64,63,61,60,58,57,55,54
	dc.b	52,51,49,48,46,44,43,41
	dc.b	40,38,37,35,34,32,31,29
	dc.b	28,27,25,24,23,21,20,19
	dc.b	18,16,15,14,13,12,11,10
	dc.b	9,8,8,7,6,5,5,4
	dc.b	4,3,3,2,2,2,1,1
	dc.b	1,1,1,1,1,1,1,2
	dc.b	2,2,3,3,4,4,5,5
	dc.b	6,7,8,8,9,10,11,12
	dc.b	13,14,15,16,18,19,20,21
	dc.b	23,24,25,27,28,29,31,32
	dc.b	34,35,37,38,40,41,43,44
	dc.b	46

;**** End of Shine! sinus wave generation

	dc.b	-1

	cnop	0,4



VBHandler:
	movem.l	a0-a6/d0-d7,-(a7)

	lea	_custom,a6
	move.w	intreqr(a6),d0
	and.w #INTF_VERTB,d0
	tst.w d0
	beq _exit2

	move.l	HARDBASE(pc),a5

	lea	_custom,a6


	tst.b	TRIG_TEXT(a5)
	beq.b	notext

	bsr	DoText

notext:	tst.b	TRIG_DOEFF(a5)
	beq.b	noeff

	cmp.b	#1,TRIG_DOEFF(a5)
	bne.b	.hey2
	bsr	DoScroller
	bra	_exit

.hey2:	bsr	DoMoron
	bra	_exit

noeff:	tst.b	TRIG_DOWIPEBL(a5)
	beq.b	nowipe

	move.w	#$0fff,d0
	bsr	DFillFull
	clr.b	TRIG_DOWIPEBL(a5)

	bra	_exit


nowipe:	tst.l	TRIG_ANIM(a5)
	beq.b	_exit

	lea	animtbl(a5),a0
	add.l	TRIG_ANIM(a5),a0
	subq.w	#4,a0
	move.l	(a0),a0
	jsr	(a0)

_exit:
;	move.w	#$0000,$dff106
;	move.w	#$000f,$dff180
	lea	mod,a0
	jsr	4(a0)
;	move.w	#$0000,$dff106
;	move.w	#$0000,$dff180
_exit2:
	lea	_custom,a6
	move.w	#INTF_VERTB,intreq(a6)		; clear interrupt request
	movem.l	(a7)+,a0-a6/d0-d7

	rte

anim1:
	move.w	CTR_FRAME(a5),d7
	mulu	#92*92*2,d7

	movea.l	hugebuffer(a5),a0
	add.l	d7,a0
	bsr	DPasteFull

	addq.w	#1,CTR_FRAME(a5)
	cmp.w	#90,CTR_FRAME(a5)
	bne.b	.hey

	clr.l	TRIG_ANIM(a5)
	clr.w	CTR_FRAME(a5)

.hey:	rts


anim2:
	move.w	CTR_FRAME(a5),d7
	mulu	#92*92*2,d7

	movea.l	hugebuffer(a5),a0
	add.l	#92*92*2*89,a0
	sub.l	d7,a0
	bsr	DPasteFull

	addq.w	#1,CTR_FRAME(a5)
	cmp.w	#45,CTR_FRAME(a5)
	bne.b	.hey

	clr.l	TRIG_ANIM(a5)
	clr.w	CTR_FRAME(a5)

.hey:	rts

anim3:
	move.w	CTR_FRAME(a5),d7
	mulu	#92*92*2,d7

	movea.l	hugebuffer(a5),a0
	add.l	d7,a0
	bsr	DPasteFull

	move.w	adder(a5),d0
	add.w	d0,CTR_FRAME(a5)

	cmp.w	#46,CTR_FRAME(a5)
	bne.b	.hey

	addq.w	#1,CTR_DIR(a5)
	cmp.w	#4,CTR_DIR(a5)
	bne.b	.skip

	clr.w	CTR_DIR(a5)
	neg.w	adder(a5)
	rts

.skip:	clr.w	CTR_FRAME(a5)
	rts


.hey:
	tst.w	CTR_FRAME(a5)
	bge.b	.hey2

	addq.w	#1,CTR_DIR(a5)
	cmp.w	#4,CTR_DIR(a5)
	bne.b	.skip2

	clr.w	CTR_DIR(a5)
	clr.w	CTR_FRAME(a5)
	neg.w	adder(a5)
.hey2:	rts

.skip2:	move.w	#45,CTR_FRAME(a5)
	rts



anim4:
	move.w	CTR_FRAME(a5),d7
	mulu	#92*92*2,d7

	movea.l	hugebuffer(a5),a0
	add.l	d7,a0
	bsr	DPasteFull

	addq.w	#1,CTR_FRAME(a5)
	cmp.w	#90,CTR_FRAME(a5)
	bne.b	.hey

	clr.w	CTR_FRAME(a5)

.hey:	rts




DoScroller:
	lea	GoTable(pc),a0

	move.w	xoffset(a5),d0
	move.w	yoffset(a5),d1

	move.b	(a0,d0.w),d0
	bge.b	.okey

	clr.w	xoffset(a5)
	move.b	(a0),d0

.okey:	move.b	(a0,d1.w),d1
	bge.b	.okey2

	clr.w	yoffset(a5)
	move.b	(a0),d1


.okey2:	and.w	#$00ff,d0
	and.w	#$00ff,d0
	addq.w	#1,xoffset(a5)
	addq.w	#1,yoffset(a5)
	bsr	CustomPaste
	rts


DoMoron:
	move.w	prevfr(a5),d0
	cmp.w	currfr(a5),d0
	bne.b	.ok
	rts

	; draw a line
.ok:	lea	framebuffer(a5),a3
	move.w	currfr(a5),d3
	move.w	d3,d4
	subq.w	#1,d4
	mulu	#184*2,d4
	add.l	d4,a3


	moveq	#92-1,d7
.loop:	move.w	(a3)+,d2
	addq.w	#2,a3
	move.w	d3,d1
	move.w	d7,d0
	bsr	DPlot
	dbra	d7,.loop

	move.w	currfr(a5),prevfr(a5)
	rts






; ***************************************************************************
; DoText
; Trigged from interrupt
; Plot one more letter from TEXT_PTR, clear TRIG_TEXT when all done
; ***************************************************************************

DoText:
	; are we waiting?
	move.b	currwait(a5),d0
	beq.b	.hey

	; finished waiting?
	addq.b	#1,waits(a5)

	cmp.b	waits(a5),d0
	beq	.wdone

	rts

	; done waiting - resume op from next int
.wdone:	clr.b	currwait(a5)
	clr.b	waits(a5)
	rts


	; no wait or otherwise, get a new char
.hey:	move.l	TEXT_PTR(a5),a0
	add.w	letter(a5),a0
	moveq	#0,d0
	move.b	(a0)+,d0
	move.b	(a0),d1

	; check special cases (not many)
	tst.b	d0
	bne.b	.t2

	; zero found, turn text off
	clr.w	letter(a5)
	clr.w	horizpos(a5)
	clr.b	TRIG_TEXT(a5)
	rts

.t2:	cmp.b	#125,d0
	bne.b	.t3

	; set wait counter
	move.b	d1,currwait(a5)
	addq.w	#2,letter(a5)
	rts

	; 32 found, do a space
.t3:	cmp.b	#32,d0
	bne.b	.t4

	addq.w	#1,letter(a5)
	add.w	#6,horizpos(a5)
	rts

	; 126 found, do a wipe
.t4:	cmp.b	#126,d0
	bne.b	.t5

	move.l	screenbuffer(a5),a1
	add.l	#(40*8)*200,a1			; a1 = textplot pos

	moveq	#20-1,d7
.lx:	clr.w	(a1)
	clr.w	320(a1)
	clr.w	640(a1)
	clr.w	960(a1)
	clr.w	1280(a1)
	clr.w	1600(a1)
	clr.w	1920(a1)
	clr.w	2240(a1)

	addq.w	#2,a1

	dbra	d7,.lx

	clr.w	horizpos(a5)
	add.w	#1,letter(a5)
	rts


	; oh no! we have to plot a letter! urrk! ;-)
.t5:	lea	font(pc),a0
	move.l	screenbuffer(a5),a1
	add.l	#(40*8)*200,a1			; a1 = textplot pos

	sub.b	#48,d0

	moveq	#0,d3
	move.w	horizpos(a5),d3
	divu	#16,d3
	add.w	d3,d3				; trick, d3 upper still valid!
	add.w	d3,a1

	swap	d3				; d3.w is now used pixels in current word

	moveq	#0,d4
	lea	sizetable(pc),a3
	move.b	(a3,d0.w),d4			; d4.b is new letter size
	add.w	d4,horizpos(a5)

	move.w	d3,d2
	move.w	#16,d5
	sub.w	d2,d5				; d5 is unused pixels

	cmp.w	d4,d5				; letter too big to mask in?
	bge.b	.okmask

	; do it the hard way
	; d5 is unused pixels
	; d4 is letter size
	; d3 is used pixels
	; d4 > d5

	add.w	d0,d0
	add.w	d0,a0

	moveq	#8-1,d1				; rows in font

.loop:	move.w	(a0),d2
	move.w	d2,d7				; d7 is backup
	lsr.w	d3,d2
	or.w	d2,(a1)				; paste upper part
	lsl.w	d5,d7
	move.w	d7,2(a1)				; paste lower part

	add.w	#150,a0
	add.w	#320,a1

	dbra	d1,.loop

	addq.w	#1,letter(a5)
	rts


	; mask letter in normally
.okmask:	add.w	d0,d0
	add.w	d0,a0

	moveq	#8-1,d1

.loop2:	move.w	(a0),d0
	lsr.w	d3,d0
	or.w	d0,(a1)

	add.w	#150,a0
	add.w	#320,a1

	dbra	d1,.loop2

	addq.w	#1,letter(a5)
	rts

sizetable:

;		 0  1  2  3  4  5  6  7  8  9
	dc.b	10,10,10,10,10,10,10,10,10,10

;		 :  ;  <  =  >  ?  @
	dc.b	00,00,00,00,00,00,00

;		 A  B  C  D  E  F  G  H  I  J  K  L  M  N  O  P  Q  R  S  T  U  V  W  X  Y  Z
	dc.b	10,10,10,10,09,08,10,10,04,06,10,07,13,10,10,10,11,10,09,10,10,10,14,10,10,09

;		
	dc.b	00,00,00,00,00,00

;		 a  b  c  d  e  f  g  h  i  j  k  l  m  n  o  p  q  r  s  t  u  v  w  x  y  z
	dc.b	10,10,10,10,10,07,10,10,04,06,10,04,14,10,10,10,10,06,07,07,10,10,14,10,10,08


	cnop	0,4




	cnop	0,4
HARDBASE:	dc.l	0			; a5 base

	cnop	0,4

	; 125,x = wait
	; 126   = wipe line
	; 0     = end

testtext:
	dc.b	125,72-7
	dc.b	"Welcome to Invention",125,200,126
	dc.b	"Triumph Software 1994",125,200,126
	dc.b	"Main code by Darkman",125,200,126
	dc.b	"Additional coding",125,200,126
	dc.b	"Warp and Smeagol",125,200,126
	dc.b	"Music by Paul van der Valk",125,200,126
	dc.b	"Gfx by Rico Holmes",125,200,0


testtext2:
	dc.b	126,"Dial Interference Triumph BBS",125,200,126
	dc.b	"Sysop   Crowley Triumph",125,200,126
	dc.b	"46 525 13136  HST V32bis",125,150,126
	dc.b	"46 525 13091  HST V32bis",125,150,126
	dc.b	"46 525 13092  HST V32bis",125,150,126
	dc.b	"46 525 13094  HST V32bis",125,150,126
	dc.b	"46 525 13095  HST V32bis",125,150,126
	dc.b	"Free DL for Norwegians",125,200,0


testtext3:
	dc.b	126,"Technical info",125,200,126
	dc.b	"Window is 92x92 pixels",125,200,126
	dc.b	"in 12 bit truecolor",125,200,126
	dc.b	"The picture is 184x184",125,200,126
	dc.b	"Each effect has 50 fps",125,200,126
	dc.b	"Source size  60 k",125,200,126
	dc.b	"Music size  11 k",125,200,126
	dc.b	"Pic size 50 k",125,200,126
	dc.b	"Hold on for more",125,200,0


testtext4:
	dc.b	126,"Greetings go out to",125,200,126
	dc.b	"All Triumph members",125,150,126
	dc.b	"Rico Holmes",125,150,126
	dc.b	"Perplex  Offence",125,150,126
	dc.b	"Kent Flash Bakke",125,150,126
	dc.b	"Skyhawk",125,150,126
	dc.b	"XTC  New Wave",125,150,126
	dc.b	"Genius  No Limits",125,150,126
	dc.b	"Positron  EON",125,150,126
	dc.b	"The Bullfrog",125,150,126
	dc.b	"Sir Loke",125,150,126
	dc.b	"and the rest",125,150,126
	dc.b	"Bye Bye",125,200,126


	cnop	0,4




; ***************************************************************************
; END ROUTINES!
; ***************************************************************************

QuitNice:
	tst.b	vb_ok(a5)
	beq.b	no_vb

	move.l	a5,-(a7)
	lea	mod,a0
	jsr	8(a0)
	move.l	(a7)+,a5

	lea	_custom,a6

	move.w	#INTF_VERTB,intena(a6)		; disable vb interrupt

	move.w	_intreq(a5),d0
	or.w	#INTF_SETCLR,d0
	move.w	d0,intreq(a6)			; restore old pending interrupts

	move.w	_intena(a5),d0
	or.w	#INTF_SETCLR,d0
	move.w	d0,intena(a6)			; restore old int bits

	move.l	_SaveVBR(a5),a4
	move.l	_OldVB(a5),$6c(a4)


no_vb:
	tst.l	_IntuitionBase(a5)
	beq.b	ep

	bsr	ReturnSpritesToNormal

	tst.b	disable_ok(a5)
	beq.b	no_dis

	move.l	_ExecBase(a5),a6
	jsr	_LVOPermit(a6)

no_dis:	move.l	wbview(a5),a1
	move.l	_GfxBase(a5),a6
	jsr	_LVOLoadView(a6)
	jsr	_LVOWaitTOF(a6)
	jsr	_LVOWaitTOF(a6)

	move.l	gb_copinit(a6),_custom+cop1lc

	move.l	_IntuitionBase(a5),a6
	jsr	_LVORethinkDisplay(a6)

	move.l	_GfxBase(a5),a1
	move.l	_ExecBase(a5),a6
	jsr	_LVOCloseLibrary(a6)

ep:	move.l	taskptr(a5),a1
	move.l	oldtaskpri(a5),d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOSetTaskPri(a6)


ey:	move.l	_IntuitionBase(a5),d0
	beq.b	e2

	movea.l	d0,a1
	jsr	_LVOCloseLibrary(a6)

e2:	move.l	_DosBase(a5),d0
	beq.b	e3

	move.l	d0,a1
	move.l	_ExecBase(a5),a6
	jsr	_LVOCloseLibrary(a6)

e3:	move.l	_screenbuffer(a5),d0
	beq.b	e31

	movea.l	d0,a1
	move.l	#(40*256*8)+8,d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

e31:	move.l	hugebuffer(a5),d0
	beq.b	e32

	movea.l	d0,a1
	move.l	#92*92*2*90,d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

e32:	move.l	_copperlist(a5),d0
	beq.b	nomorebufstofree

	movea.l	d0,a1
	move.l	#copperlist_SIZEOF+8,d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

nomorebufstofree:
	move.l	_SaveSP(a5),-(a7)

	move.l	a5,a1
	move.l	#gldata_SIZEOF,d0
	move.l	_ExecBase(a5),a6
	jsr	_LVOFreeMem(a6)

	move.l	(a7)+,d0

	move.l	d0,a7
	moveq	#0,d0

	rts


; ***********************************************
; ReturnSpritesToNormal
; ***********************************************

ReturnSpritesToNormal:
	move.l	wbscreen(a5),d0
	beq.b	.error
	move.l	d0,a0

	lea	taglist(a5),a1
	move.l	#VTAG_SPRITERESN_SET,(a1)+
	move.l	oldres(a5),(a1)+
	move.l	#TAG_DONE,(a1)

	lea	taglist(a5),a1
	move.l	sc_ViewPort+vp_ColorMap(a0),a0
	move.l	_GfxBase(a5),a6
	jsr	_LVOVideoControl(a6)		; return sprites to normal.

	move.l	wbscreen(a5),a0
	move.l	_IntuitionBase(a5),a6
	jsr	_LVOMakeScreen(a6)		; and rebuild screen

	move.l	wbscreen(a5),a1
	sub.l	a0,a0
	jsr	_LVOUnlockPubScreen(a6)

.error
        rts




		incdir	"tg94:"

font:	incbin	"font.raw"			; was 416*16*2, now 1856*8*2


wbname:		dc.b	"Workbench",0
gfxname:		dc.b	"graphics.library",0
intname:		dc.b	"intuition.library",0
dosname:		dc.b	"dos.library",0

	cnop	0,4
static_copper:
	MO %0000000000000011,$1fc		; set AGA 4x fetchmode

	dc.l	$200ffffe

;	MO $0000,SPR0DATA
;	MO $0000,SPR1DATA
;	MO $0000,SPR2DATA
;	MO $0000,SPR3DATA
;	MO $0000,SPR4DATA
;	MO $0000,SPR5DATA
;	MO $0000,SPR6DATA
;	MO $0000,SPR7DATA

	MO $0000,COLOR00
	MO $0000,COLOR00
	MO $0000,COLOR00
	MO $0000,COLOR00
	MO $0000,COLOR00
	MO $0000,COLOR00
	MO $0000,COLOR00
	MO $0000,COLOR00

	MO $0000,BPL1PTH
	MO $0000,BPL1PTL
	MO $0000,BPL2PTH
	MO $0000,BPL2PTL
	MO $0000,BPL3PTH
	MO $0000,BPL3PTL
	MO $0000,BPL4PTH
	MO $0000,BPL4PTL
	MO $0000,BPL5PTH
	MO $0000,BPL5PTL
	MO $0000,BPL6PTH
	MO $0000,BPL6PTL
	MO $0000,BPL7PTH
	MO $0000,BPL7PTL
	MO $0000,BPL8PTH
	MO $0000,BPL8PTL

	MO %0000010000100000,DMACON

	;   H421HDCGXXX8LIEX
	MO %0000001000010000,BPLCON0	; set 8 planes


	; interleaved bpls, modulo = 288 bytes???

	MO 288,BPL1MOD
	MO 288,BPL2MOD


	MO $2c81,DIWSTRT
	MO $2cc1,DIWSTOP

;	MO %0010011100000000,$01e4

	MO %0000000001010000,DDFSTRT
	MO %0000000110110000,DDFSTOP

	MO $0000,BPLCON1
	MO $0000,BPLCON2

	dc.w	$0106,%0000000000000000
	dc.l	$01800000
	dc.l	$01820850

	dc.l	-1

	; block is here!

static_endcopper:
	MO	$0000,$0106
	MO	$0fff,$0182

	WA	$df,$ff
	WA	$09,$2c

	MO	%1000001000000000,BPLCON0

	WA	$FF,$ff			;end...
	WA	$FF,$ff

	dc.l	-1

logo:	incbin	"trlogo2.pch"
picture:	incbin	"puma184.pch"

	section	chex,code_c

mod:	incbin	"fred.hybris_light"
